lorom
; Optimise and move the escape timer to be able to load all the room enemies graphic, usefull for custom escapes
; Contain a generic routine to spawn the timer for your custom escape
; Not for vanilla escapes, use this if you have an escape timer that is not classic Ceres or MB, so for custom escapes
; Wont work with some bosses, but if you know VRAM well its possible to make it works with most bosses



; Tiles
org $B0C000
	incbin etimer_gfx.bin
; SpriteMaps
org $809FE8
	incbin etimer_sprmaps.bin





; ᶜᵒᵈᵉ 

; Vanilla escape timers, only load gfx (look lower for a generic routine call instead)
; Its commented cause we need way more work to make this change work with vanilla Ceres etc., but a good look of where those are
org $A6C4CB
;	DW $0200 : DL $B0C000 : DW $6D00  ;Values used to put in $D0
;	DW $0200 : DL $B0C000 : DW $6D00










;;; Example of a generic routine to call (JSL), to spawn the whole escape timer
; Uncoment code lines to make it compiles

;FREE SPACE;
org $80D1D0



Gen_Etimer:
;LoadTimerGFX
    LDX $0330
	LDA #$0200 : STA $D0,x
	LDA #$C000 : STA $D2,x
	LDA #$B0B0 : STA $D4,x
	LDA #$6D00 : STA $D5,x
	TXA : CLC : ADC #$0007 : STA $0330
;ChangeMusic
	TDC : JSL $808FC1
	LDA #$FF24 : JSL $808FC1
;RunTimer
	LDA #$0002 : STA $0943   ;Run timer as MB timer (#$0001 for Ceres, Ceres cinematic used if event E not set I think)
	LDA #$E0E6 : STA $0A5A   ;Enable timer handler in $80
	RTL

org $AAC9CB ;Repoint VRAM address and reduce transfer size
dw $814B, $0400 : dl $AFE200 : dw $6E00
org $8D8F17 ;Adjust spritemaps accordingly
; Enemy projectile $B1C0 (Golden Torizo egg)
dw $0001, $C3F8 : db $F8 : dw $2B04
dw $0001, $C3F8 : db $F8 : dw $2B8C
dw $0001, $C3F8 : db $F8 : dw $2BCC
dw $0001, $C3F8 : db $F8 : dw $2AE0
dw $0001, $C3F8 : db $F6 : dw $22E2
dw $0001, $C3F8 : db $F6 : dw $22E4
dw $0001, $C3F8 : db $F6 : dw $22E6
dw $0001, $C3F8 : db $F6 : dw $22E8
dw $0001, $C3F8 : db $F6 : dw $22EA
dw $0001, $C3F8 : db $F6 : dw $22EC
dw $0002, $0000 : db $FE : dw $22FF, $01F8 : db $FE : dw $22FE
dw $0002, $0000 : db $FE : dw $22EF, $01F8 : db $FE : dw $22EE
dw $0001, $C3F8 : db $F8 : dw $6B04
dw $0001, $C3F8 : db $F8 : dw $6B8C
dw $0001, $C3F8 : db $F8 : dw $6BCC
dw $0001, $C3F8 : db $F8 : dw $6AE0
dw $0001, $C3F8 : db $F6 : dw $62E2
dw $0001, $C3F8 : db $F6 : dw $62E4
dw $0001, $C3F8 : db $F6 : dw $62E6
dw $0001, $C3F8 : db $F6 : dw $62E8
dw $0001, $C3F8 : db $F6 : dw $62EA
dw $0001, $C3F8 : db $F6 : dw $62EC
dw $0002, $0000 : db $FE : dw $62FF, $01F8 : db $FE : dw $62FE
dw $0002, $0000 : db $FE : dw $62EF, $01F8 : db $FE : dw $62EE


