;-----------------------------------------------------------
;---------------Metroids Stay Dead--------------------------
;-----------------OmegaDragnet9-----------------------------
;-----------------------------------------------------------

;So long as you are comfortable with marking the rooms cleared
;with events matching the room index,
;this will keep you from having multiple states
;when all you want is just a hall clear of metroids. 

;Thanks to P.JBoy for the Banklogs
;Thanks to MetroidNerd#9001 for Room Index Events.
;This is intended to work with "Event Triggers from Killing Enemies."
;But any event PLM will do just as well. 

;This ASM does NOT set events.

lorom

;--------------Defines-----------------------

!VanillaInitial = $EA4F
!A3Freespace    = $A3FA00 ;$A3F330		;in SMART the Initial AI must be changed to THIS. 
!A7Freespace    = $A7FF82

org !A3Freespace 

LDA $079D

; OR USE THIS INSTEAD OF ROOM INDEX

; LDX $0E54						;Enemy Index
; LDA $0FB4,x					;Speed 1 Value


JSL $808233						;Check against Event A with Room Index	
BCS END							;Event set, mark enemies as dead
JMP !VanillaInitial				;Otherwise load them as usual. 

END:

JSL !A7Freespace : RTL			

org !A7Freespace : JSR $A943 : RTL	;Sets enemy properties as dead



