LoRom

org $819A47 : LDA SRAMAddressTable,X : Skip 7 : LDA SRAMAddressTable,X : Skip 11 : CPY #$0A00
org $819CAE : LDA SRAMAddressTable,X : Skip 12 : CPY #$0A00
org $818000 : JMP SaveGame
org $818085 : JMP LoadGame
org $81EF20 
;org $81EFE0 ;repointed to harmonize with new starting area ASM, originally $81EF20 
SRAMAddressTable: DW $0010,$0A10,$1410
CheckSumAdd: CLC : ADC $14 : INC A : STA $14 : RTS

SaveGame: PHP : REP #$30 : PHB : PHX : PHY
	PEA $7E7E : PLB : PLB : STZ $14 : AND #$0003 : ASL A : STA $12
	LDA $079F : INC A : XBA : TAX : LDY #$00FE
	-	LDA $07F7,Y : STA $CD50,X : DEX #2 : DEY #2 : BPL -		;Saves the current map
	LDY #$005E
	-	LDA $09A2,Y : STA $D7C0,Y : DEY : DEY : BPL -			;Saves current equipment	
	LDA $078B : STA $D916		;Current save for the area
	LDA $079F : STA $D918		;Current Area
	LDX $12 : LDA SRAMAddressTable,X : TAX : LDY #$0000		;How much data to save for items and event bits
	-	LDA $D7C0,Y : STA $700000,X : JSR CheckSumAdd : INX #2 : INY #2 : CPY #$0160 : BNE -
	LDY #$06FE		;How much data to save for maps
	-	LDA $CD52,Y : STA $700000,X : INX #2 : DEY #2 : BPL -	
	PEA $7F7F : PLB : PLB : LDY #$00FE		;How much extra data to save per save
	-	LDA $FE00,Y : STA $700000,X : INX #2 : DEY #2 : BPL -
	LDY #$00FE : LDX #$1E10					;How much extra data to save globally (affects all saves)
	-	LDA $FF00,Y : STA $700000,X : INX #2 : DEY #2 : BPL -
	LDX $12 : LDA $14 : STA $700000,X : STA $701FF0,X : EOR #$FFFF : STA $700008,X : STA $701FF8,X
	PLY : PLX : PLB : PLP : RTL

LoadGame: PHP : REP #$30 : PHB : PHX : PHY
	PEA $7E7E : PLB : PLB : STZ $14 : AND #$0003 : ASL A : STA $12
	TAX : LDA SRAMAddressTable,X : STA $16 : TAX : LDY #$0000		;How much data to load for items and event bits
	-	LDA $700000,X : STA $D7C0,Y : JSR CheckSumAdd : INX #2 : INY #2 : CPY #$0160 : BNE -
		LDA $D916 : STA $078B		;Current save for the area
		LDA $D918 : STA $079F		;Current Area
	LDY #$06FE		;How much data to load for maps
	-	LDA $700000,X : STA $CD52,Y : INX #2 : DEY #2 : BPL -
	PEA $7F7F : PLB : PLB : LDY #$00FE		;How much extra data to load per save
	-	LDA $700000,X : STA $FE00,Y : INX #2 : DEY #2 : BPL -
	LDY #$00FE : LDX #$1E10					;How much extra data to load globally (affects all saves)
	-	LDA $700000,X : STA $FF00,Y : INX #2 : DEY #2 : BPL -
	-	LDX $12 : LDA $700000,X : CMP $14 : BNE $0B : EOR #$FFFF : CMP $14 : BNE $02 : BRA -
	LDA $14 : CMP $701FF0,X : BNE +++ : EOR #$FFFF : CMP $701FF8,X : BNE +++
	-	PEA $7E7E : PLB : PLB : LDY #$005E
	-	LDA $D7C0,Y : STA $09A2,Y : DEY #2 : BPL -		;Loads current equipment	
	PLY : PLX : PLB : PLP : CLC : RTL
+++	LDX $16 : LDY #$09FE : LDA #$0000
	-	STA $700000,X : INX #2 : DEY #2 : BPL -
	PLY : PLX : PLB : PLP : SEC : RTL