
lorom

;-------------------------------------------------------------------------------
;===============================================================================
;THIS NEXT NOTE APPLIES TO EACH LINE BETWEEN THE 2 ;=================ETC
;NOTE = IF YOU WISH TO USE A DIFFERENT BANK TO LOAD YOUR ROOM ID POINTERS FROM
	  ;CONCERNING CHOSEN BITS (SET/RESET), CHOSEN EVENT AND CHOSEN ACQUIRED
	  ;WEAPON CHECKS, THEN CHANGE THE $B8 TO WHICHEVER BANK YOU WISH TO USE
	  ;IN THE 4 LONG WORDS BELOW

!BITCMPRRSTLD = $B80000,x
!BITRESET = $B80002,x
!EVENTLOAD = $B80004,x
!ACQUIREDWPN = $B80006,x
;===============================================================================
;-------------------------------------------------------------------------------

;ROOM EVENTS (MAIN CODE):

org $8FF000		;(***GATE EVENT***)
			;THIS CAN GO ANYWHERE THERE IS FREE SPACE IN BANK $8F ONLY ($A0 BYTES LONG) - (***GATE EVENT***) USE AS EVENT HEADER TYPE POINTER FOR GATE EVENTS)
			;IF YOU DO MOVE THIS ORG TO A DIFFERENT SPOT IN BANK $8F, YOU WILL NEED TO CHANGE THE EVENT POINTERS YOU USE WITH EVERY EVENT ACCORDINGLY AND
			;YOU WILL ALSO NEED TO CHANGE THE EVENT POINTERS INSIDE THE 'mdb_state.txt' FILE PROVIDED FOR USE IN SMILE ACCORDINGLY TOO

	JML JUMPTOGATECODE
	JML JUMPTOVARIACODE		;(VARIA SUIT STATE CHECK)--$F004 = STATE TYPE POINTER FOR VARIA SUIT ( BY DEFAULT) >>> ***GATE EVENT*** + $04
	JML JUMPTOSPRINGBCODE		;(SPRING BALL STATE CHECK)--$F008 = STATE TYPE POINTER FOR SPRINGBALL ( BY DEFAULT) >>> ***GATE EVENT*** + $08
	JML JUMPTOMORPHBCODE		;(MORPH BALL STATE CHECK)--$F00C = STATE TYPE POINTER FOR MORPHBALL ( BY DEFAULT) >>> ***GATE EVENT*** + $0C
	JML JUMPTOSCREWACODE		;(SCREW ATTACK STATE CHECK)--$F010 = STATE TYPE POINTER FOR SCREW ATTACK ( BY DEFAULT) >>> ***GATE EVENT*** + $10
	JML JUMPTOGRAVITYSCODE		;(GRAVITY SUIT STATE CHECK)--$F014 = STATE TYPE POINTER FOR GRAVITY SUIT ( BY DEFAULT) >>> ***GATE EVENT*** + $14
	JML JUMPTOHIGHJBCODE		;(HIGH JUMP BOOTS STATE CHECK)--$F018 = STATE TYPE POINTER FOR HIGH JUMP BOOTS ( BY DEFAULT) >>> ***GATE EVENT*** + $18
	JML JUMPTOSPACEJCODE		;(SPACE JUMP STATE CHECK)--$F01C = STATE TYPE POINTER FOR SPACE JUMP ( BY DEFAULT) >>> ***GATE EVENT***+ $1C
	JML JUMPTOBOMBCODE		;(BOMB STATE CHECK)--$F020 = STATE TYPE POINTER FOR BOMB ( BY DEFAULT) >>> ***GATE EVENT*** + $20
	JML JUMPTOSBOOSTCODE		;(SPEED BOOSTER STATE CHECK)--$F024 = STATE TYPE POINTER FOR SPEED BOOSTER ( BY DEFAULT) >>> ***GATE EVENT*** + $24
	JML JUMPTOGRAPPLEBCODE		;(GRAPPLE BEAM STATE CHECK)--$F028 = STATE TYPE POINTER FOR GRAPPLE BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $28
	JML JUMPTOXRAYSCODE		;(XRAY SCOPE STATE CHECK)--$F02C = STATE TYPE POINTER FOR XRAY SCOPE ( BY DEFAULT) >>> ***GATE EVENT*** + $2C
	JML JUMPTOEVENTCODE		;(EVENT STATE CHECK[$E612])--$F030 = STATE TYPE POINTER FOR EVENTS ($E612) ( BY DEFAULT) >>> ***GATE EVENT*** + $30
	JML JUMPTOCHARGEBCODE		;(CHARGE BEAM STATE CHECK)--$F034 = STATE TYPE POINTER FOR CHARGE BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $34
	JML JUMPTOWAVEBCODE		;(WAVE BEAM STATE CHECK)--$F038 = STATE TYPE POINTER FOR WAVE BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $38
	JML JUMPTOICEBCODE		;(ICE BEAM STATE CHECK)--$F03C = STATE TYPE POINTER FOR ICE BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $3C
	JML JUMPTOSPAZERBCODE		;(SPAZER BEAM STATE CHECK)--$F040 = STATE TYPE POINTER FOR SPAZER BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $40
	JML JUMPTOPLASMABCODE		;(PLASMA BEAM STATE CHECK)--$F044 = STATE TYPE POINTER FOR PLASMA BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $44
	JML JUMPTORESERVETCODE		;(RESERVE TANK STATE CHECK)--$F048 = STATE TYPE POINTER FOR RESERVE TANKS ( BY DEFAULT) >>> ***GATE EVENT*** + $48
	JML JUMPTOMORPHMISSCODE		;(MORPH AND MISSILES STATE CHECK)--$F04C = STATE TYPE POINTER FOR MORPH & MISSILES ( BY DEFAULT) >>> ***GATE EVENT*** + $4C
	JML JUMPTOMISSCODE		;(MISSILE STATE CHECK)--$F050 = STATE TYPE POINTER FOR MISSILES ( BY DEFAULT) >>> ***GATE EVENT*** + $50
	JML JUMPTOSMISSCODE		;(SUPER MISSILE STATE CHECK)--$F054 = STATE TYPE POINTER FOR SUPER MISSILES ( BY DEFAULT) >>> ***GATE EVENT*** + $54
	JML JUMPTOPBOMBCODE		;(POWER BOMB STATE CHECK)--$F058 = STATE TYPE POINTER FOR POWER BOMBS ( BY DEFAULT) >>> ***GATE EVENT*** + $58

;-------------------------------------------------------------------------------

	JML VARIACODE		;(VARIA SUIT STATE)--$F05C = STATE TYPE POINTER FOR VARIA SUIT ( BY DEFAULT) >>> ***GATE EVENT*** + $5C
	JML SPRINGBCODE		;(SPRING BALL STATE)--$F060 = STATE TYPE POINTER FOR SPRINGBALL ( BY DEFAULT) >>> ***GATE EVENT*** + $60
	JML SCREWACODE		;(SCREW ATTACK STATE)--$F064 = STATE TYPE POINTER FOR SCREW ATTACK ( BY DEFAULT) >>> ***GATE EVENT*** + $64
	JML GRAVITYSCODE		;(GRAVITY SUIT STATE)--$F068 = STATE TYPE POINTER FOR GRAVITY SUIT ( BY DEFAULT) >>> ***GATE EVENT*** + $68
	JML HIGHJBCODE		;(HIGH JUMP BOOTS STATE)--$F06C = STATE TYPE POINTER FOR HIGH JUMP BOOTS ( BY DEFAULT) >>> ***GATE EVENT*** + $6C
	JML SPACEJCODE		;(SPACE JUMP STATE)--$F070 = STATE TYPE POINTER FOR SPACE JUMP ( BY DEFAULT) >>> ***GATE EVENT***+ $70
	JML BOMBCODE		;(BOMB STATE)--$F074 = STATE TYPE POINTER FOR BOMB ( BY DEFAULT) >>> ***GATE EVENT*** + $74
	JML GRAPPLEBCODE		;(GRAPPLE BEAM STATE)--$F078 = STATE TYPE POINTER FOR GRAPPLE BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $78
	JML XRAYSCODE		;(XRAY SCOPE STATE)--$F07C = STATE TYPE POINTER FOR XRAY SCOPE ( BY DEFAULT) >>> ***GATE EVENT*** + $7C
	JML CHARGEBCODE		;(CHARGE BEAM STATE)--$F080 = STATE TYPE POINTER FOR CHARGE BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $80
	JML WAVEBCODE		;(WAVE BEAM STATE)--$F084 = STATE TYPE POINTER FOR WAVE BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $84
	JML ICEBCODE		;(ICE BEAM STATE)--$F088 = STATE TYPE POINTER FOR ICE BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $88
	JML SPAZERBCODE		;(SPAZER BEAM STATE)--$F08C = STATE TYPE POINTER FOR SPAZER BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $8C
	JML PLASMABCODE		;(PLASMA BEAM STATE)--$F090 = STATE TYPE POINTER FOR PLASMA BEAM ( BY DEFAULT) >>> ***GATE EVENT*** + $90
	JML RESERVETCODE		;(RESERVE TANK STATE)--$F094 = STATE TYPE POINTER FOR RESERVE TANKS ( BY DEFAULT) >>> ***GATE EVENT*** + $94
	JML MISSCODE		;(MISSILE STATE)--$F098 = STATE TYPE POINTER FOR MISSILES ( BY DEFAULT) >>> ***GATE EVENT*** + $98
	JML SMISSCODE		;(SUPER MISSILE STATE)--$F09C = STATE TYPE POINTER FOR SUPER MISSILES ( BY DEFAULT) >>> ***GATE EVENT*** + $9C

;-------------------------------------------------------------------------------
org $8EE602		;THIS CAN GO ANYWHERE IN ROM WHERE THERE IS FREE SPACE ($0426 BYTES WORTH)

JUMPTOGATECODE:

	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHGATE
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHGATE:
	JML JUMPLONGENDTOINX3:

JUMPTOVARIACODE:
	LDA $09A4
	AND #$0001
	BEQ BRANCHVARIA
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHVARIA
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHVARIA:
	JML JUMPLONGENDTOINX3

JUMPTOSPRINGBCODE:
	LDA $09A4
	AND #$0002
	BEQ BRANCHSPRINGB
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHSPRINGB
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHSPRINGB:
	JML JUMPLONGENDTOINX3

JUMPTOMORPHBCODE:
	LDA $09A4
	AND #$0004
	BEQ BRANCHMORPHB
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHMORPHB
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHMORPHB:
	JML JUMPLONGENDTOINX3

JUMPTOSCREWACODE:
	LDA $09A4
	AND #$0008
	BEQ BRANCHSCREWA
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHSCREWA
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHSCREWA:
	JML JUMPLONGENDTOINX3

JUMPTOGRAVITYSCODE:
	LDA $09A4
	AND #$0020
	BEQ BRANCHGRAVITYS
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHGRAVITYS
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHGRAVITYS:
	JML JUMPLONGENDTOINX3

JUMPTOHIGHJBCODE:
	LDA $09A4
	AND #$0100
	BEQ BRANCHHIGHJB
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHHIGHJB
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHHIGHJB:
	JML JUMPLONGENDTOINX3

JUMPTOSPACEJCODE:
	LDA $09A4
	AND #$0200
	BEQ BRANCHSPACEJ
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHSPACEJ
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHSPACEJ:
	JML JUMPLONGENDTOINX3

JUMPTOBOMBCODE:
	LDA $09A4
	AND #$1000
	BEQ BRANCHBOMB
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHBOMB
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHBOMB:
	JML JUMPLONGENDTOINX3

JUMPTOSBOOSTCODE:
	LDA $09A4
	AND #$2000
	BEQ BRANCHSBOOST
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHSBOOST
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHSBOOST:
	JML JUMPLONGENDTOINX3

JUMPTOGRAPPLEBCODE:
	LDA $09A4
	AND #$4000
	BEQ BRANCHGRAPPLEB
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHGRAPPLEB
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHGRAPPLEB:
	JML JUMPLONGENDTOINX3

JUMPTOXRAYSCODE:
	LDA $09A4
	AND #$8000
	BEQ BRANCHXRAYS
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHXRAYS
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHXRAYS:
	JML JUMPLONGENDTOINX3

JUMPTOEVENTCODE:
	LDA $0000,x
	AND #$00FF
	JSL $808233
	BCC BRANCHEVENT
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHEVENT
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHEVENT:
	JML JUMPLONGENDTOINX3

JUMPTOCHARGEBCODE:
	LDA $09A8
	AND #$1000
	BEQ BRANCHCHARGEB
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHCHARGEB
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHCHARGEB:
	JML JUMPLONGENDTOINX3

JUMPTOWAVEBCODE:
	LDA $09A8
	AND #$0001
	BEQ BRANCHWAVEB
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHWAVEB
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHWAVEB:
	JML JUMPLONGENDTOINX3

JUMPTOICEBCODE:
	LDA $09A8
	AND #$0002
	BEQ BRANCHICEB
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHICEB
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHICEB:
	JML JUMPLONGENDTOINX3

JUMPTOSPAZERBCODE:
	LDA $09A8
	AND #$0004
	BEQ BRANCHSPAZERB
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHSPAZERB
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHSPAZERB:
	JML JUMPLONGENDTOINX3

JUMPTOPLASMABCODE:
	LDA $09A8
	AND #$0008
	BEQ BRANCHPLASMAB
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHPLASMAB
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHPLASMAB:
	JML JUMPLONGENDTOINX3

JUMPTORESERVETCODE:
	LDA $09D4
	CMP #$0064
	BPL BRANCHRESERVET
BRANCHRESERVETEND:
	JML JUMPLONGENDTOINX3
BRANCHRESERVET:
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHRESERVETEND
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP

JUMPTOMORPHMISSCODE:
	LDA $09A4
	BIT #$0004
	BEQ BRANCHMORPHMISS
	LDA $09C8
	BEQ BRANCHMORPHMISS
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHMORPHMISS
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHMORPHMISS:
	JML JUMPLONGENDTOINX3

JUMPTOMISSCODE:
	LDA $09C8
	BEQ BRANCHMISS
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHMISS
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHMISS:
	JML JUMPLONGENDTOINX3

JUMPTOSMISSCODE:
	LDA $09CC
	BEQ BRANCHSMISS
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHSMISS
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHSMISS:
	JML JUMPLONGENDTOINX3

JUMPTOPBOMBCODE:
	LDA $09D0
	BEQ BRANCHPBOMB
	LDA $0000,x
	AND #$00FF
	JSL SUBROUTINE1
	BCC BRANCHPBOMB
	LDA $0001,x
	TAX
	JML JUMPLONGENDTOJMP
BRANCHPBOMB:
	JML JUMPLONGENDTOINX3

;-------------------------------------------------------------------------------

VARIACODE:
	LDA $09A4
	AND #$0001
	BEQ VARIA
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
VARIA:
	JML JUMPLONGENDTOINX2

SPRINGBCODE:
	LDA $09A4
	AND #$0002
	BEQ SPRINGB
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
SPRINGB:
	JML JUMPLONGENDTOINX2

SCREWACODE:
	LDA $09A4
	AND #$0008
	BEQ SCREWA
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
SCREWA:
	JML JUMPLONGENDTOINX2

GRAVITYSCODE:
	LDA $09A4
	AND #$0020
	BEQ GRAVITYS
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
GRAVITYS:
	JML JUMPLONGENDTOINX2

HIGHJBCODE:
	LDA $09A4
	AND #$0100
	BEQ HIGHJB
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
HIGHJB:
	JML JUMPLONGENDTOINX2

SPACEJCODE:
	LDA $09A4
	AND #$0200
	BEQ SPACEJ
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
SPACEJ:
	JML JUMPLONGENDTOINX2

BOMBCODE:
	LDA $09A4
	AND #$1000
	BEQ BOMB
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
BOMB:
	JML JUMPLONGENDTOINX2

GRAPPLEBCODE:
	LDA $09A4
	AND #$4000
	BEQ GRAPPLEB
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
GRAPPLEB:
	JML JUMPLONGENDTOINX2

XRAYSCODE:
	LDA $09A4
	AND #$8000
	BEQ XRAYS
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
XRAYS:
	JML JUMPLONGENDTOINX2

CHARGEBCODE:
	LDA $09A8
	AND #$1000
	BEQ CHARGEB
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
CHARGEB:
	JML JUMPLONGENDTOINX2

WAVEBCODE:
	LDA $09A8
	AND #$0001
	BEQ WAVEB
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
WAVEB:
	JML JUMPLONGENDTOINX2

ICEBCODE:
	LDA $09A8
	AND #$0002
	BEQ ICEB
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
ICEB:
	JML JUMPLONGENDTOINX2

SPAZERBCODE:
	LDA $09A8
	AND #$0004
	BEQ SPAZERB
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
SPAZERB:
	JML JUMPLONGENDTOINX2

PLASMABCODE:
	LDA $09A8
	AND #$0008
	BEQ PLASMAB
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
PLASMAB:
	JML JUMPLONGENDTOINX2

RESERVETCODE:
	LDA $09D4
	CMP #$0064
	BPL RESERVET
	JML JUMPLONGENDTOINX2
RESERVET:
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP

MISSCODE:
	LDA $09C8
	BEQ MISS
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
MISS:
	JML JUMPLONGENDTOINX2

SMISSCODE:
	LDA $09CC
	BEQ SMISS
	LDA $0000,x
	TAX
	JML JUMPLONGENDTOJMP
SMISS:
	JML JUMPLONGENDTOINX2

;-------------------------------------------------------------------------------

org $8FFFF9		;THIS CAN GO ANYWHERE THERE IS FREE SPACE IN BANK $8F ONLY ($07 BYTES WORTH)

JUMPLONGENDTOJMP:
JMP $E5E6
JUMPLONGENDTOINX3:
INX
JUMPLONGENDTOINX2:
INX : INX : RTS

;-------------------------------------------------------------------------------

org $80D000		;THIS CAN GO ANYWHERE THERE IS FREE SPACE IN BANK $80 ONLY ($1C BYTES WORTH)

SUBROUTINE1:

	PHX : PHY : PHP
	REP #$30
	JSL $80818E
	LDA $7EDA20,x
	AND $05E7
	BNE BRANCH2
	PLP : PLY : PLX
	CLC : RTL
	BRANCH2:
	PLP : PLY : PLX : SEC : RTL

;-------------------------------------------------------------------------------

;BTS POINTERS

org $94A18B

	DW SHOTSONCRMBLBLCK

org $94A1AB

	DW SHOTSONCRMBLBLCK

org $9494EB

	DW HORIZCOLLIS

org $94950B

	DW VERTCOLLIS

org $A0C86F

	DW STARTENCOLLISION
	
org $A0C8A3

	DW STARTENCOLLISION

org $94A04A

	DW LOADROOMSTTPTR

org $94A18D

	DW LOADROOMSTTPTR

org $94A1AD

	DW LOADROOMSTTPTR

org $94A853

	DW LOADROOMSTTPTR

org $949F36

	DW NORCTN, NORCTN

org $949F46

	DW RCTNLEFTRESET, RCTNRIGHTRESET

org $949F56

	DW RCTNLEFTSET, RCTNRIGHTSET

;-------------------------------------------------------------------------------

;ENEMY REACTION TO CRUMBLE BLOCK COLLISIONS ON  BTS 10, 11 & 12

org $A0F7D3					;THIS CAN GO ANYWHERE THERE IS FREE SPACE IN BANK $A0 ONLY ($05 BYTES WORTH)

STARTENCOLLISION:
	JSL NEXTENCOLLISION
	RTS

org $9FFEC5				;THIS CAN GO ANYWHERE IN ROM WHERE THERE IS FREE SPACE ($13B BYTES WORTH)

UNSOLID:
	CLC : RTS

ACTSOLID:
	SEC : RTS

ENCOLLPTRTBL:

	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW UNSOLID, UNSOLID, UNSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	 ;^BTS-10^,^BTS-11^,^BTS-12^,

	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID
	DW ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID, ACTSOLID

NEXTENCOLLISION:
	LDX $0DC4
	LDA $7F6402,x
	AND #$00FF
	ASL : TAX
	DB $BD
	DW ENCOLLPTRTBL
	INC
	BEQ $03
	JMP (ENCOLLPTRTBL,x)
	CLC
	RTL

;-------------------------------------------------------------------------------

org $94B200			;THIS CAN GO ANYWHERE THERE IS FREE SPACE IN BANK $94 ONLY ($07D7 WORTH)

;SAMUS REACTION TO BLOCK COLLISION

HORIZCOLLIS:
	LDX $0DC4
	LDA $7F6402,x
	AND #$00FF
	ASL : TAX
	DB $BD
	DW HORCOLLPTRTBL
	INC
	BEQ $03
	JMP (HORCOLLPTRTBL,x)
	CLC : RTS
	
VERTCOLLIS:

	LDX $0DC4
	LDA $7F6402,x
	AND #$00FF
	ASL : TAX
	DB $BD
	DW VERTCOLLPTRTBL
	INC
	BEQ $03
	JMP (VERTCOLLPTRTBL,x)
	CLC : RTS

HORCOLLPTRTBL:

	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW BTS10COLLH, BTS11COLLH, BTS12COLLH, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB
	DW $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB, $90CB

VERTCOLLPTRTBL:

	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW BTS10COLLV, BTS11COLLV, BTS12COLLV, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102
	DW $9102, $9102, $9102, $9102, $9102, $9102, $9102, $9102

BTS10COLLH:

	LDA #$0001 : STA $7EDE18 : STA $7EDE16 : JMP $90CB

BTS11COLLH:

	LDA #$0000 : STA $7EDE18 : JMP $90CB

BTS12COLLH:

	LDA #$0000 : STA $7EDE16 : JMP $90CB

BTS10COLLV:

	LDA #$0001 : STA $7EDE18 : STA $7EDE16 : JMP $9102

BTS11COLLV:

	LDA #$0000 : STA $7EDE18 : JMP $9102

BTS12COLLV:

	LDA #$0000 : STA $7EDE16 : JMP $9102

;-------------------------------------------------------------------------------

;SHOT REACTION TO CRUMBLE BLOCKS

SHTCBLPTRTBL:

	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D59, $9D59, $9D59, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	 ;BTS^10,BTS^11,BTS^12,

	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B
	DW $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B, $9D5B

SHOTSONCRMBLBLCK:

	LDX $0DC4
	LDA $7F6402,x
	AND #$00FF
	ASL : TAX
	DB $BD
	DW SHTCBLPTRTBL
	INC
	BEQ $03
	JMP (SHTCBLPTRTBL,x)
	CLC : RTS

;-------------------------------------------------------------------------------

LOADROOMSTTPTR:

	LDX $07BB
	JSR EVENTCMPR
	AND !BITCMPRRSTLD
	CMP !BITCMPRRSTLD
	BEQ $03
	JMP GATESOPENING
	JMP GATESCLOSING

EVENTCMPR:

	LDX $07BB
	LDA !EVENTLOAD
	CMP #$0020
	BEQ BRANCH20
	CMP #$0022
	BEQ BRANCH22
	CMP #$0024
	BEQ BRANCH24
	CMP #$0026
	BEQ BRANCH26
	CMP #$0028
	BEQ BRANCH28
	CMP #$002A
	BEQ BRANCH2A
	CMP #$002C
	BEQ BRANCH2C
	CMP #$002E
	BEQ BRANCH2E
	CMP #$0030
	BEQ BRANCH30
	CMP #$0032
	BEQ BRANCH32
	CMP #$0034
	BEQ BRANCH34	
	CMP #$0036
	BEQ BRANCH36	
	CMP #$0038
	BEQ BRANCH38	
	CMP #$003A
	BEQ BRANCH3A	
	CMP #$003C
	BEQ BRANCH3C	
	LDA $7EDA3E : RTS
	BRANCH20:
	LDA $7EDA20 : RTS
	BRANCH22:
	LDA $7EDA22 : RTS
	BRANCH24:
	LDA $7EDA24 : RTS
	BRANCH26:
	LDA $7EDA26 : RTS
	BRANCH28:
	LDA $7EDA28 : RTS
	BRANCH2A:
	LDA $7EDA2A : RTS
	BRANCH2C:
	LDA $7EDA2C : RTS
	BRANCH2E:
	LDA $7EDA2E : RTS
	BRANCH30:
	LDA $7EDA30 : RTS
	BRANCH32:
	LDA $7EDA32 : RTS
	BRANCH34:
	LDA $7EDA34 : RTS
	BRANCH36:
	LDA $7EDA36 : RTS
	BRANCH38:
	LDA $7EDA38 : RTS
	BRANCH3A:
	LDA $7EDA3A : RTS
	BRANCH3C:
	LDA $7EDA3C : RTS

GATESCLOSING:

	LDX $0DC4
	LDA $7F6402,x
	AND #$00FF
	ASL : TAX
	DB $BD
	DW CLOSEGATEPTRTBL
	INC
	BEQ $03
	JMP (CLOSEGATEPTRTBL,x)
	CLC : RTS

CLOSEGATEPTRTBL:

	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW CGINST2, CGINST2, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	   ;BTS^48,  BTS^49,

	DW CGINST2, CGINST2, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	   ;BTS^50,  BTS^51,

	DW CGINST2, CGINST2, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	   ;BTS^58,  BTS^59,

	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73

GATESOPENING:

	LDX $0DC4
	LDA $7F6402,x
	AND #$00FF
	ASL : TAX
	DB $BD
	DW OPENGATEPTRTBL
	INC
	BEQ $03
	JMP (OPENGATEPTRTBL,x)
	CLC : RTS

OPENGATEPTRTBL:

	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW OGINST2, OGINST2, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	   ;BTS^48,  BTS^49,

	DW OGINST2, OGINST2, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	   ;BTS^50,  BTS^51,

	DW OGINST2, OGINST2, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	   ;BTS^58,  BTS^59,

	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73
	DW $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73, $9E73

CGINST2:
	LDA $7EDE18
	CMP #$0001
	BEQ $0F
	LDA $7EDE1A
	CMP #$0001
	BEQ $03
	JMP GATEOPRTECLS
	JMP $9E73
	LDA $7EDE16
	CMP #$0001
	BEQ $F4
	LDX $0DDE
	LDA $0C18,x
	AND #$0001
	CMP #$0001
	BEQ $DA
	BRA $E4

GATEOPRTECLS:
	
	LDX $0DC4
	LDA $7F6401,x
	AND #$FF00
	XBA
	BMI $0D
	ASL : TAX
	LDA $9EB6,x
	JSL $8484E7
	REP #$40
	SEC : RTS
	AND #$007F
	ASL : TAY
	LDA $079F
	ASL : TAX
	LDA $9FC6,x
	STA $12
	LDA ($12),y
	JSL $8484E7
	REP #$40
	SEC : RTS

OGINST2:
	LDA $7EDE18
	CMP #$0001
	BEQ $0F
	LDA $7EDE1A
	CMP #$0001
	BEQ $03
	JMP OPENOPRTEOPN
	JMP $9E73
	LDA $7EDE16
	CMP #$0001
	BEQ $F4
	LDX $0DDE
	LDA $0C18,x
	AND #$0001
	CMP #$0001
	BEQ $DA
	BRA $E4

OPENOPRTEOPN:
	LDX $0DC4
	LDA $7F6401,x
	AND #$FF00
	XBA
	BMI $0D
	ASL : TAX
	LDA $9EC6,x
	JSL $8484E7
	REP #$40
	SEC : RTS
	AND #$007F
	ASL : TAY
	LDA $079F
	ASL : TAX
	LDA $9FC6,x
	STA $12
	LDA ($12),y
	JSL $8484E7
	REP #$40
	SEC : RTS

;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------

org $84C80E

NORCTN:
	DW $C5A1, $AAE3

org $84FFF0		;THIS CAN GO ANYWHERE THERE IS FREE SPACE IN BANK $84 ONLY ($10 BYTES WORTH)

RCTNLEFTRESET:

	DW CLOSEGATELEFT, $AAE3

RCTNLEFTSET:

	DW OPENGATELEFT, $AAE3

RCTNRIGHTRESET:

	DW CLOSEGATERIGHT, $AAE3

RCTNRIGHTSET:

	DW OPENGATERIGHT, $AAE3



;-------------------------------------------------------------------------------

org $84BC15

	DW TILEOPENEDGATE, OPENGATEENDINS

org $84BC3E

	DW CLOSEGATEENDINS


org $84A61B

	DB $DC

org $84A623

	DW $84DC

org $84A66B

	DB $DC

org $84A673

	DB $DC

org $84A517

	DW $8005, $C0D7, $8012, $8012, $8012, $8012, $0000, $8005
	DW $C0D7, $C012, $8012, $8012, $8012, $0000, $8005, $C0D7
	DW $C012, $C012, $8012, $8012, $0000, $8005, $C0D7, $C012
	DW $C012, $C012, $8012, $0000, $8005, $C0D7, $C012, $C012
	DW $C012, $C012, $0000, $8005, $C0D6, $C0FF, $C0FF, $C0FF
	DW $C0FF, $0000

;-------------------------------------------------------------------------------

org $84C70A

	DW ANYWPNLEFT, ANYWPNRIGHT, MISSILELEFT, MISSILERIGHT, SMISSILELEFT, SMISSILERIGHT, PBOMBLEFT, PBOMBRIGHT
	DW ICELEFT, ICERIGHT, WAVELEFT, WAVERIGHT, PLASMALEFT, PLASMARIGHT, SPAZERLEFT, SPAZERRIGHT
	DW CHARGELEFT, CHARGERIGHT, BOMBLEFT, BOMBRIGHT

org $84C6EC

	JSR BTSTBLLEFT

org $84C6FC

	JSR BTSTBLRIGHT

org $84F000			;THIS CAN GO ANYWHERE THERE IS FREE SPACE IN BANK $84 ONLY ($01F2 WORTH)

ANYWPNLEFT:
	DW $0001, ANYWPNTILELEFT, $86BC

ANYWPNRIGHT:
	DW $0001, ANYWPNTILERIGHT, $86BC

MISSILELEFT:
	DW $0001, MISSILETILELEFT, $86BC

MISSILERIGHT:
	DW $0001, MISSILETILERIGHT, $86BC

SMISSILELEFT:
	DW $0001, SMISSILETILELEFT, $86BC

SMISSILERIGHT:
	DW $0001, SMISSILETILERIGHT, $86BC

PBOMBLEFT:
	DW $0001, PBOMBTILELEFT, $86BC

PBOMBRIGHT:
	DW $0001, PBOMBTILERIGHT, $86BC

ICELEFT:
	DW $0001, ICETILELEFT, $86BC

ICERIGHT:
	DW $0001, ICETILERIGHT, $86BC

WAVELEFT:
	DW $0001, WAVETILELEFT, $86BC

WAVERIGHT:
	DW $0001, WAVETILERIGHT, $86BC

PLASMALEFT:
	DW $0001, PLASMATILELEFT, $86BC

PLASMARIGHT:
	DW $0001, PLASMATILERIGHT, $86BC

SPAZERLEFT:
	DW $0001, SPAZERTILELEFT, $86BC

SPAZERRIGHT:
	DW $0001, SPAZERTILERIGHT, $86BC

CHARGELEFT:
	DW $0001, CHARGETILELEFT, $86BC

CHARGERIGHT:
	DW $0001, CHARGETILERIGHT, $86BC

BOMBLEFT:
	DW $0001, BOMBTILELEFT, $86BC

BOMBRIGHT:
	DW $0001, BOMBTILERIGHT, $86BC

CLOSEGATELEFT:

	JSL CLOSEGATELEFTINS
	RTS

OPENGATELEFT:
	JSL OPENGATELEFTINS
	RTS

CLOSEGATERIGHT:

	JSL CLOSEGATERIGHTINS
	RTS

OPENGATERIGHT:
	JSL OPENGATERIGHTINS
	RTS

;-------------------------------------------------------------------------------

ANYWPNTILELEFT:

	DW $0001, $80D6, $00FF, $0001, $C0DB, $0001, $0001, $8430, $0000

ANYWPNTILERIGHT:

	DW $0002, $80D6, $C4DB, $00FF, $0001, $8030, $0000

MISSILETILELEFT:

	DW $0001, $80D6, $00FF, $0001, $C0DA, $0001, $0001, $8430, $0000

MISSILETILERIGHT:

	DW $0002, $80D6, $C4DA, $00FF, $0001, $8030, $0000

SMISSILETILELEFT:

	DW $0001, $80D6, $00FF, $0001, $C0D9, $0001, $0001, $8430, $0000

SMISSILETILERIGHT:

	DW $0002, $80D6, $C4D9, $00FF, $0001, $8030, $0000

PBOMBTILELEFT:

	DW $0001, $80D6, $00FF, $0001, $C0DC, $0001, $0001, $8430, $0000

PBOMBTILERIGHT:

	DW $0002, $80D6, $84DC, $00FF, $0001, $C030, $0000

ICETILELEFT:

	DW $0001, $80D6, $00FF, $0001, $C034, $0001, $0001, $8430, $0000

ICETILERIGHT:

	DW $0002, $80D6, $C434, $00FF, $0001, $8030, $0000

WAVETILELEFT:

	DW $0001, $80D6, $00FF, $0001, $C033, $0001, $0001, $8430, $0000

WAVETILERIGHT:

	DW $0002, $80D6, $C433, $00FF, $0001, $8030, $0000

PLASMATILELEFT:

	DW $0001, $80D6, $00FF, $0001, $C032, $0001, $0001, $8430, $0000

PLASMATILERIGHT:

	DW $0002, $80D6, $C432, $00FF, $0001, $8030, $0000

SPAZERTILELEFT:

	DW $0001, $80D6, $00FF, $0001, $C035, $0001, $0001, $8430, $0000

SPAZERTILERIGHT:

	DW $0002, $80D6, $C435, $00FF, $0001, $8030, $0000

CHARGETILELEFT:

	DW $0001, $80D6, $00FF, $0001, $C031, $0001, $0001, $8430, $0000

CHARGETILERIGHT:

	DW $0002, $80D6, $C431, $00FF, $0001, $8030, $0000

BOMBTILELEFT:

	DW $0001, $80D6, $00FF, $0001, $C0D8, $0001, $0001, $8430, $0000

BOMBTILERIGHT:

	DW $0002, $80D6, $C4D8, $00FF, $0001, $8030, $0000

BTSTBLLEFT:

	LDA BTSPTRTBLLEFT,x
	RTS

BTSTBLRIGHT:

	LDA BTSPTRTBLRIGHT,x
	RTS

TILEOPENEDGATE:

	DW $8005, $C0D6, $B0FF, $B0FF, $B0FF, $B0FF, $0000


OPENGATEENDINS:

	JSL OPENEDGATEINS
	JMP $BBDD

CLOSEGATEENDINS:

	JSL CLOSEDGATEINS 
	JMP $BBDD

;--------------------------------------------------------------------------------------------------------------------

org $DFD4DF			;THIS CAN GO ANYWHERE IN ROM WHERE THERE IS FREE SPACE ($088E WORTH)

BTSPTRTBLLEFT:

	DW $C048, $0000, $C048, $0000, $C048, $0000, $C048, $C048
	DW $C048, $0000, $C048, $0000, $C048, $0000, $C048, $0000
	DW $C048, $0000, $C048, $0000

BTSPTRTBLRIGHT:

	DW $0000, $C049, $0000, $C049, $0000, $C049, $0000, $0000
	DW $0000, $C049, $0000, $C049, $0000, $C049, $0000, $C049
	DW $0000, $C049, $0000, $C049

OPENEDGATEINS:

	LDA #$0000 : STA $7EDE1A : STA $7EDE18 : STA $7EDE16 : RTL

CLOSEDGATEINS:

	LDA #$0000 : STA $7EDE1A : STA $7EDE16 : RTL

;--------------------------------------------------------------------------------------------------------------------

ANYWPNL:
	JMP ANYWPN2L
CHARGEBL:
	JMP CHARGEB2L
PLASMABL:
	JMP PLASMAB2L
MISSILEL:
	JMP MISSILE2L
CLOSEGATELEFTINS:
	LDX $07BB
	LDA !ACQUIREDWPN
	CMP #$0001
	BEQ MISSILEL
	CMP #$0002
	BEQ SMISSILEL
	CMP #$0003
	BEQ PBOMBL
	CMP #$0005
	BEQ BOMBL
	CMP #$0010
	BEQ WAVEBL
	CMP #$0020
	BEQ ICEBL
	CMP #$0040
	BEQ SPAZERBL
	CMP #$0080
	BEQ PLASMABL
	CMP #$0011
	BEQ CHARGEBL
	CMP #$0012
	BEQ ANYWPNL
	JMP DONTOPR
SMISSILEL:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0200
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTLFT
PBOMBL:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0300
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTLFT
BOMBL:
	LDX $0DDE
	LDA $0C18,x
	AND #$8FFF
	CMP #$0501
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTLFT
WAVEBL:
	LDX $0DDE
	LDA $0C18,x
	AND #$0501
	CMP #$0001
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTLFT
ICEBL:
	LDX $0DDE
	LDA $0C18,x
	AND #$0002
	CMP #$0002
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTLFT
SPAZERBL:
	LDX $0DDE
	LDA $0C18,x
	AND #$0004
	CMP #$0004
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTLFT
PLASMAB2L:
	LDX $0DDE
	LDA $0C18,x
	AND #$0008
	CMP #$0008
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTLFT
CHARGEB2L:
	LDX $0DDE
	LDA $0C18,x
	AND #$0010
	CMP #$0010
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTLFT
ANYWPN2L:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0300
	BEQ $03
	JMP OPRRSTLFT
	JMP DONTOPR

MISSILE2L:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0100
	BEQ OPRRSTLFT
	CMP #$0200
	BEQ OPRRSTLFT
DONTOPR:
	LDA #$0057
	JSL $8090CB
	LDA #$0000
	STA $1C37,y
	RTL
OPRRSTLFT:
	LDA $1C87,y
	INC : INC
FINALJUMPRRST:
	LDX #$004E
	CMP $1C87,x
	BEQ $06
	DEX : DEX
	BPL $F7
	BRA $08
	LDA $1D77,x
	BNE $03
	INC $1D77,x
	LDA #$0000
	STA $1C37,y
	SEC
	BRA OVERHERE

BRANCH26L1:
	JMP BRANCH26L

BRANCH28L1:
	JMP BRANCH28L

BRANCH2AL1:
	JMP BRANCH2AL

BRANCH2CL1:
	JMP BRANCH2CL

BRANCH2EL1:
	JMP BRANCH2EL

BRANCH30L1:
	JMP BRANCH30L

BRANCH32L1:
	JMP BRANCH32L

BRANCH34L1:
	JMP BRANCH34L

BRANCH36L1:
	JMP BRANCH36L

BRANCH38L1:
	JMP BRANCH38L

BRANCH3AL1:
	JMP BRANCH3AL

BRANCH3CL1:
	JMP BRANCH3CL

OVERHERE:
	LDX $07BB
	LDA !EVENTLOAD
	CMP #$0020
	BEQ BRANCH20L
	CMP #$0022
	BEQ BRANCH22L
	CMP #$0024
	BEQ BRANCH24L
	CMP #$0026
	BEQ BRANCH26L1
	CMP #$0028
	BEQ BRANCH28L1
	CMP #$002A
	BEQ BRANCH2AL1
	CMP #$002C
	BEQ BRANCH2CL1
	CMP #$002E
	BEQ BRANCH2EL1
	CMP #$0030
	BEQ BRANCH30L1
	CMP #$0032
	BEQ BRANCH32L1
	CMP #$0034
	BEQ BRANCH34L1
	CMP #$0036
	BEQ BRANCH36L1
	CMP #$0038
	BEQ BRANCH38L1
	CMP #$003A
	BEQ BRANCH3AL1
	CMP #$003C
	BEQ BRANCH3CL1
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA3E
	AND !BITRESET
	STA $7EDA3E
	RTL

BRANCH20L:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA20
	AND !BITRESET
	STA $7EDA20
	RTL

BRANCH22L:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA22
	AND !BITRESET
	STA $7EDA22
	RTL

BRANCH24L:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA24
	AND !BITRESET
	STA $7EDA24
	RTL

BRANCH26L:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA26
	AND !BITRESET
	STA $7EDA26
	RTL

BRANCH28L:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA28
	AND !BITRESET
	STA $7EDA28
	RTL

BRANCH2AL:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA2A
	AND !BITRESET
	STA $7EDA2A
	RTL

BRANCH2CL:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA2C
	AND !BITRESET
	STA $7EDA2C
	RTL

BRANCH2EL:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA2E
	AND !BITRESET
	STA $7EDA2E
	RTL

BRANCH30L:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA30
	AND !BITRESET
	STA $7EDA30
	RTL

BRANCH32L:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA32
	AND !BITRESET
	STA $7EDA32
	RTL	

BRANCH34L:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA34
	AND !BITRESET
	STA $7EDA34
	RTL	

BRANCH36L:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA36
	AND !BITRESET
	STA $7EDA36
	RTL	

BRANCH38L:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA38
	AND !BITRESET
	STA $7EDA38
	RTL	

BRANCH3AL:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA3A
	AND !BITRESET
	STA $7EDA3A
	RTL	

BRANCH3CL:
	JSR GOTOSR
	LDA !BITRESET
	LDA $7EDA3C
	AND !BITRESET
	STA $7EDA3C
	RTL			

;--------------------------------------------------------------------------------------------------------------------
 
GOTOSR:
	LDA #$0001
	STA $7EDE1A
	LDX $07BB
	RTS

;--------------------------------------------------------------------------------------------------------------------




ANYWPNBLO:
	JMP ANYWPNB2LO

CHARGEBLO:
	JMP CHARGEB2LO

PLASMABLO:
	JMP PLASMAB2LO

MISSILELO:
	JMP MISSILE2LO

OPENGATELEFTINS:
	LDX $07BB
	LDA !ACQUIREDWPN
	CMP #$0001
	BEQ MISSILELO
	CMP #$0002
	BEQ SMISSILELO
	CMP #$0003
	BEQ PBOMBLO
	CMP #$0005
	BEQ BOMBLO
	CMP #$0010
	BEQ WAVEBLO
	CMP #$0020
	BEQ ICEBLO
	CMP #$0040
	BEQ SPAZERBLO
	CMP #$0080
	BEQ PLASMABLO
	CMP #$0011
	BEQ CHARGEBLO
	CMP #$0012
	BEQ ANYWPNBLO
	JMP DONTOPR
SMISSILELO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0200
	BEQ $03
	JMP DONTOPR
	JMP OPRSETLFT
PBOMBLO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0300
	BEQ $03
	JMP DONTOPR
	JMP OPRSETLFT
BOMBLO:
	LDX $0DDE
	LDA $0C18,x
	AND #$8FFF
	CMP #$0501
	BEQ $03
	JMP DONTOPR
	JMP OPRSETLFT
WAVEBLO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0501
	CMP #$0001
	BEQ $03
	JMP DONTOPR
	JMP OPRSETLFT
ICEBLO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0002
	CMP #$0002
	BEQ $03
	JMP DONTOPR
	JMP OPRSETLFT
SPAZERBLO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0004
	CMP #$0004
	BEQ $03
	JMP DONTOPR
	JMP OPRSETLFT
PLASMAB2LO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0008
	CMP #$0008
	BEQ $03
	JMP DONTOPR
	JMP OPRSETLFT
CHARGEB2LO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0010
	CMP #$0010
	BEQ $03
	JMP DONTOPR
	JMP OPRSETLFT
ANYWPNB2LO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0300
	BEQ $03
	JMP OPRSETLFT
	JMP DONTOPR

;--------------------------------------------------------------------------------------------------------------------

MISSILE2LO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0100
	BEQ BRANCHSETLFT
	CMP #$0200
	BEQ BRANCHSETLFT
	JMP DONTOPR
BRANCHSETLFT:
	BRA OPRSETLFT

BRANCH26R:
	JMP BRANCH262R

BRANCH28R:
	JMP BRANCH282R

BRANCH2AR:
	JMP BRANCH2A2R

BRANCH2CR:
	JMP BRANCH2C2R

BRANCH2ER:
	JMP BRANCH2E2R

BRANCH30R:
	JMP BRANCH302R

BRANCH32R:
	JMP BRANCH322R

BRANCH34R:
	JMP BRANCH342R

BRANCH36R:
	JMP BRANCH362R

BRANCH38R:
	JMP BRANCH382R

BRANCH3AR:
	JMP BRANCH3A2R

BRANCH3CR:
	JMP BRANCH3C2R

OPRSETLFT:
	LDA $1C87,y
	INC : INC
FINALJUMPRSET:
	LDX #$004E
	CMP $1C87,x
	BEQ $06
	DEX : DEX
	BPL $F7
	BRA $08
	LDA $1D77,x
	BNE $03
	INC $1D77,x
	LDA #$0000
	STA $1C37,y
	SEC
	LDX $07BB
	LDA !EVENTLOAD
	CMP #$0020
	BEQ BRANCH20R
	CMP #$0022
	BEQ BRANCH22R
	CMP #$0024
	BEQ BRANCH24R
	CMP #$0026
	BEQ BRANCH26R
	CMP #$0028
	BEQ BRANCH28R
	CMP #$002A
	BEQ BRANCH2AR
	CMP #$002C
	BEQ BRANCH2CR
	CMP #$002E
	BEQ BRANCH2ER
	CMP #$0030
	BEQ BRANCH30R
	CMP #$0032
	BEQ BRANCH32R	
	CMP #$0034
	BEQ BRANCH34R	
	CMP #$0036
	BEQ BRANCH36R	
	CMP #$0038
	BEQ BRANCH38R	
	CMP #$003A
	BEQ BRANCH3AR	
	CMP #$003C
	BEQ BRANCH3CR
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA3E
	ORA !BITCMPRRSTLD
	STA $7EDA3E
	RTL
BRANCH20R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA20
	ORA !BITCMPRRSTLD
	STA $7EDA20
	RTL
BRANCH22R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA22
	ORA !BITCMPRRSTLD
	STA $7EDA22
	RTL
BRANCH24R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA24
	ORA !BITCMPRRSTLD
	STA $7EDA24
	RTL
BRANCH262R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA26
	ORA !BITCMPRRSTLD
	STA $7EDA26
	RTL
BRANCH282R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA28
	ORA !BITCMPRRSTLD
	STA $7EDA28
	RTL
BRANCH2A2R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA2A
	ORA !BITCMPRRSTLD
	STA $7EDA2A
	RTL
BRANCH2C2R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA2C
	ORA !BITCMPRRSTLD
	STA $7EDA2C
	RTL
BRANCH2E2R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA2E
	ORA !BITCMPRRSTLD
	STA $7EDA2E
	RTL
BRANCH302R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA30
	ORA !BITCMPRRSTLD
	STA $7EDA30
	RTL
BRANCH322R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA32
	ORA !BITCMPRRSTLD
	STA $7EDA32
	RTL
BRANCH342R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA34
	ORA !BITCMPRRSTLD
	STA $7EDA34
	RTL
BRANCH362R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA36
	ORA !BITCMPRRSTLD
	STA $7EDA36
	RTL
BRANCH382R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA38
	ORA !BITCMPRRSTLD
	STA $7EDA38
	RTL
BRANCH3A2R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA3A
	ORA !BITCMPRRSTLD
	STA $7EDA3A
	RTL
BRANCH3C2R:
	JSR GOTOSR
	LDA !BITCMPRRSTLD
	LDA $7EDA3C
	ORA !BITCMPRRSTLD
	STA $7EDA3C
	RTL

;--------------------------------------------------------------------------------------------------------------------


ANYWPNBR:
	JMP ANYWPNB2R

CHARGEBR:
	JMP CHARGEB2R

PLASMABR:
	JMP PLASMAB2R

MISSILER:
	JMP MISSILE2R

CLOSEGATERIGHTINS:

	LDX $07BB
	LDA !ACQUIREDWPN
	CMP #$0001
	BEQ MISSILER
	CMP #$0002
	BEQ SMISSILER
	CMP #$0003
	BEQ PBOMBR
	CMP #$0005
	BEQ BOMBR
	CMP #$0010
	BEQ WAVEBR
	CMP #$0020
	BEQ ICEBR
	CMP #$0040
	BEQ SPAZERBR
	CMP #$0080
	BEQ PLASMABR
	CMP #$0011
	BEQ CHARGEBR
	CMP #$0012
	BEQ ANYWPNBR
	JMP DONTOPR
SMISSILER:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0200
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTRGHT
PBOMBR:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0300
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTRGHT
BOMBR:
	LDX $0DDE
	LDA $0C18,x
	AND #$8FFF
	CMP #$0501
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTRGHT
WAVEBR:
	LDX $0DDE
	LDA $0C18,x
	AND #$0501
	CMP #$0001
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTRGHT
ICEBR:
	LDX $0DDE
	LDA $0C18,x
	AND #$0002
	CMP #$0002
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTRGHT
SPAZERBR:
	LDX $0DDE
	LDA $0C18,x
	AND #$0004
	CMP #$0004
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTRGHT
PLASMAB2R:
	LDX $0DDE
	LDA $0C18,x
	AND #$0008
	CMP #$0008
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTRGHT
CHARGEB2R:
	LDX $0DDE
	LDA $0C18,x
	AND #$0010
	CMP #$0010
	BEQ $03
	JMP DONTOPR
	JMP OPRRSTRGHT
ANYWPNB2R:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0300
	BEQ $08
OPRRSTRGHT:
	LDA $1C87,y
	DEC : DEC
	JMP FINALJUMPRRST
	JMP DONTOPR

;--------------------------------------------------------------------------------------------------------------------

MISSILE2R:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0100
	BEQ BRANCHRSTRGHT
	CMP #$0200
	BEQ BRANCHRSTRGHT
	JMP DONTOPR
BRANCHRSTRGHT:
	JMP OPRRSTRGHT

;--------------------------------------------------------------------------------------------------------------------

ANYWPNBRO:
	JMP ANYWPNB2RO

CHARGEBRO:
	JMP CHARGEB2RO

PLASMABRO:
	JMP PLASMAB2RO

MISSILERO:
	JMP MISSILE2RO

OPENGATERIGHTINS:

	LDX $07BB
	LDA !ACQUIREDWPN
	CMP #$0001
	BEQ MISSILERO
	CMP #$0002
	BEQ SMISSILERO
	CMP #$0003
	BEQ PBOMBRO
	CMP #$0005
	BEQ BOMBRO
	CMP #$0010
	BEQ WAVEBRO
	CMP #$0020
	BEQ ICEBRO
	CMP #$0040
	BEQ SPAZERBRO
	CMP #$0080
	BEQ PLASMABRO
	CMP #$0011
	BEQ CHARGEBRO
	CMP #$0012
	BEQ ANYWPNBRO
	JMP DONTOPR
SMISSILERO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0200
	BEQ $03
	JMP DONTOPR
	JMP OPRSETRGHT
PBOMBRO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0300
	BEQ $03
	JMP DONTOPR
	JMP OPRSETRGHT
BOMBRO:
	LDX $0DDE
	LDA $0C18,x
	AND #$8FFF
	CMP #$0501
	BEQ $03
	JMP DONTOPR
	JMP OPRSETRGHT
WAVEBRO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0501
	CMP #$0001
	BEQ $03
	JMP DONTOPR
	JMP OPRSETRGHT
ICEBRO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0002
	CMP #$0002
	BEQ $03
	JMP DONTOPR
	JMP OPRSETRGHT
SPAZERBRO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0004
	CMP #$0004
	BEQ $03
	JMP DONTOPR
	JMP OPRSETRGHT
PLASMAB2RO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0008
	CMP #$0008
	BEQ $03
	JMP DONTOPR
	JMP OPRSETRGHT
CHARGEB2RO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0010
	CMP #$0010
	BEQ $03
	JMP DONTOPR
	JMP OPRSETRGHT
ANYWPNB2RO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0300
	BEQ $08
OPRSETRGHT:
	LDA $1C87,y
	DEC : DEC
	JMP FINALJUMPRSET
	JMP DONTOPR

;--------------------------------------------------------------------------------------------------------------------

MISSILE2RO:
	LDX $0DDE
	LDA $0C18,x
	AND #$0FFF
	CMP #$0100
	BEQ BRANCHSETRGHT
	CMP #$0200
	BEQ BRANCHSETRGHT
	JMP DONTOPR
BRANCHSETRGHT:
	JMP OPRSETRGHT
