;Apply this patch to the LongBeam.IPS before applying it to the ROM.

lorom

org $80808C
DW $2000
;This is a bit in beam array used by Long Beam. Other possible values are 4000 and 8000.

org $8080C6
DB $97, $00
;These 2 bytes are a pointer to where place graphics of Long Beam item in Bank $89. $9700 by default. 

org $8081F5
DW $FA00
;This is a pointer to code for a Long Beam in bank $90.

org $8081FC
DW $FA00
;This is a pointer to code for a Long Beam in bank $90. Must be the same value as above.

org $8081FF
DB $7A, 00
;These 2 bytes are a pointer in bank $90 to where place code of Long Beam. $87A00 by default. Must be the same pointer as above.

org $808207
DW $2000
;This is a bit in beam array used by Long Beam. Other possible values are 4000 and 8000. Must be the same value as at $80808C

org $80821E
DW $FFA0
;How far can fly charged shot to the left from Samus.

org $808223
DW $0060
;How far can fly charged shot to the right from Samus.

org $80822F
DW $FF88
;How far can fly charged shot to the up from Samus.

org $808234
DW $0068
;How far can fly charged shot to the down from Samus.

org $808242
DW $FFC0
;How far can fly regular shot to the left from Samus.

org $808247
DW $0040
;How far can fly regular shot to the right from Samus.

org $808253
DW $FFA8
;How far can fly regular shot to the up from Samus.

org $808258
DW $0048
;How far can fly regular shot to the down from Samus.