lorom

;------------------Animation Removal for New Game Intro Scenes 02 and 03-------------------------------------
;-----------------------------------OmegaDragnet9------------------------------------------------------------

;Purpose: During the Intro sequence, 4 animated screens emerge using GFX from $95F90E.
;Currently I have had no luck in manipulating the tilemaps for New Game Intro Scenes Tilemap pointers $978F14 and $979714
;from within SMILE RF. 

;This is to gain a little bit more control over these by removing the animated sprite that is normally over top of these still images. 

;Credits to P.JBoy for the Banklogs
;and PHOSPHOTiDYL because the Expanded Title resource was studied to understand the spritemap format better.
;Thanks also to RaccoonSam whose own tutorial on the matter was extremely instrumental in this. 

;Don't place transparent tiles over where the animated sprites would normally load as this only masks them. 
;Beware that Intro Scene 03 will still have a mirroring effect in the region where the Metroid Tube is. 

org $8C8CF3	;Baby Metroid Being Delivered (Frame 1)

DW $0006
DW $0004 : DB $F4 : DW $0CEB	;Changing the first value from $3xxx to $0xxx. This should place the sprites behind BG0
DW $01FC : DB $F4 : DW $0CEA
DW $01F4 : DB $F4 : DW $0CE9
DW $0004 : DB $04 : DW $0CF2
DW $0004 : DB $FC : DW $0CE2
DW $C3F4 : DB $FC : DW $0CE0

DW $0006						;Frame 2 (The next two frames are just duplicates of Frame 1)
DW $0004 : DB $F4 : DW $0CEB
DW $01FC : DB $F4 : DW $0CEA
DW $01F4 : DB $F4 : DW $0CE9
DW $0004 : DB $04 : DW $0CF2
DW $0004 : DB $FC : DW $0CE2
DW $C3F4 : DB $FC : DW $0CE0

DW $0006						;Frame 3
DW $0004 : DB $F4 : DW $0CEB
DW $01FC : DB $F4 : DW $0CEA
DW $01F4 : DB $F4 : DW $0CE9
DW $0004 : DB $04 : DW $0CF2
DW $0004 : DB $FC : DW $0CE2
DW $C3F4 : DB $FC : DW $0CE0

org $8C8D53

;Metroid Examined Frame1
DW $0001	
DW $C3F8 : DB $F8 : DW $0D99	;Place the sprites behind BG0 (Make sure to be mindful not to place behind transparent tiles.)

;Metroid Examined Frame2 
DW $0001	
DW $C3F8 : DB $F8 : DW $0D9B

;Metroid Examined Frame3
DW $0001	
DW $C3F8 : DB $F8 : DW $0D9D

