lorom

;You should somewhat know the basics, like if used with multiple patches cause not only use normal freespace but block BTS freespace

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Extended Event PLM ;;;
;;;;;;;;;;;;;;;;; Benox50
;Total rewrite of the event PLM, now the event always trigger, can:
; -Set/Clear an event, either a trigger for samus or check if room item collected
; -Trigger earthquake if wanted

;Copy both F00B files in "smile\files\PLM"
;*** More info on how to use in the PLM description ( F00B.txt )







;***Here are pointers of block BTS reaction, the only one you need is "#BTS_PLM_Event", was 2 lazy to target it alone but here is a nice group of that type that can be used for more
;If you made edits to those already you should double check and merge this with your own stuff

;;;;;;;;;;;;;;;;;;;;;;;;
;;; Collision touch trigger type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; PLMs entries for block collision reaction - special ( special air, special solid...) ;
;org $949139
;DW $D044, $D048, $D04C, $D050, $D054, $D058, $D05C, $D060, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $D038, $D040
;DW $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $F9F0, $F8B0, $F870 ;modified right here
;DW $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $FAC0 ;modified
;DW $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F, $B62F
;DW $B62F, $B62F, $B62F, $B62F, $C83E, $EED3, $B6FF, $B6D7, $B6DB, $B6E3, $B6E7, $B6EF, $B6F3, $B76B, #BTS_PLM_Event, $B62F
;Same as above but area dependant
;org $9491D9
; ...


!bts = $4E
org !bts*2+$949139		;Formula credit to Smiley
dw #BTS_PLM_Event



;***Next is the PLM headers, and yes the BTS create a PLM so we have 2 PLMs total in this story

;;;;; PLM head ;;;;;
;Event PLM, BTS trigger
org $84B65F
BTS_PLM_Event:
	DW #PLM_EventBTS_Init, #PLM_EventBTS_Inst
;Event PLM
org $84F00B
PLM_Event:
	DW #PLM_Event_Init, #PLM_Event_Inst





;***Now the thing itself

; FREE SPACE ;
org $84F020
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Event PLM ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;
{
;;PLM settings, XY ZZ

; ZZ Event to set
; XY Index of item PLM in room which need to be collected to trigger event
; Y At 0 for using it as trigger instead of checking an item (means item 0 is 1...)
; XY Highest bit set for earthquake (8000), second highest bit clear event instead of set (4000)

;
!PLM_Event_QuakeDelay = #$0028

;; Instructions lists ;;
;Event PLM
PLM_Event_Inst:
	DW $86C1, #PLM_Event_PreIns ;Set Pre-Instruction
	DW $86B4 ;Sleep
	;DW $86BC ;Delete
;Player touch trigger PLM (spawned by special block BTS)
PLM_EventBTS_Inst:
	DW $86BC ;Delete, code is in his Init.
	
;; Initiation ;;
PLM_Event_Init:
print " PLM_Event (Initiation): ", pc
;Set event based on trigger?
	LDA $1DC7,y : AND #$3F00 : BNE +
;Yes, create custom block collision reaction (player trigger)
	LDX $1C87,y : LDA #$304E : JSR $82B4 ;Block 3 (special air) BTS 4E
+
;No, Get out of here stalker!
	RTS


;** Main **, pre-instruction (run code each frame)
PLM_Event_PreIns:
print " PLM_Event (PreIns): ", pc
;Handle earthquake sound 
	;LDA $1DC7,x : BPL +
	LDA $1D77,x : BEQ +
	JSR PLM_Event_QuakeSnd 
;Decide set event type
+
	LDA $1DC7,x : AND #$3F00 : BNE PLM_Event_Item
;Trigger type function already done in init.
PLM_Event_Trig:	
	;INC $1D27,x : INC $1D27,x
	;TDC : INC : STA $7EDE1C,x
	RTS

;Set event based on item
PLM_Event_Item:
print " PLM_Event (Item Event): ", pc
;Index said item PLM in room
;Offset of +1, so offset it backward, convert to word and at end of PLM entries array
	XBA : DEC : ASL : STA $16
	LDA #$004E : SEC : SBC $16 : TAX
;Bit index, then check if his item index set with bitmask
	LDA $1DC7,x : JSL $80818E
	LDA $7ED870,x ;Not sure why items PLMs use $7ED830,x tho, cause its $7ED870,x
	LDX $1C27
	AND $05E7 : BNE PLM_Event_PreIns2
;Item not collected
	RTS
;Item collected


;Set/Clear event
PLM_Event_PreIns2:
	LDA $1DC7,x : BIT #$4000 : BNE +
	AND #$00FF : TAY : JSL $808233 : BCS PLM_Event_End ;Event already set?
	TYA : JSL $8081FA ;Set event
	BRA ++
+	
	AND #$00FF : TAY : JSL $808233 : BCC PLM_Event_End ;Event already clear?
	TYA : JSL $808212 ;Clear event

;Start earthquake?
print " PLM_Event (Start Quake): ", pc
++
	LDA $1DC7,x : BPL PLM_Event_End
;Start earthquake (also add some random to the duration but its kinda small cream on cake)
	LDA #$000B : STA $183E ;Set quake type
	JSL $808111 : BMI + ;Get random num
	AND #$001F : BRA ++ ;Set range to small positive
+
	ORA #$FFE0 ;Set range to small negative
++	
	CLC : ADC !PLM_Event_QuakeDelay : STA $1D77,x : STA $1840 ;Set earthquake delay with small rand offset
PLM_Event_End:
	RTS


;Set event based on trigger
PLM_EventBTS_Init:
print " PLM_Event (Touch Event): ", pc
	LDX #$0050
-
;Get Event PLM index with search by match nth block of room (cause both same spot)
	DEX #2 : BMI +
	LDA $1C87,x : CMP $1C87,y : BNE -
	JMP PLM_Event_PreIns2 ;Set/Clear event of event PLM
+
	RTS


;Handle earthquake sound
PLM_Event_QuakeSnd:
print " PLM_Event (Quake Snd): ", pc
	DEC $1D77,x
	LDA $05B6 : AND #$000F : BNE + ;Create frames skip branch, so play snd at intervals
	LDA #$0046 : JSL $8090CB ;Snd type to use
+
	RTS

}


