lorom

org $84F060

DW INIT : DW INST

INST:
DW MAIN


INIT:
	PHY
	PHX
	TYX
	LDY #$0000	; set up PLM height variable
	LDA $1C87,X	; PLMs Nth position
	LSR		; divide by 2
	CMP $07A5	; Compare to Rooms Width in Blocks (used to see if its on the first line or not)
	BMI INITEND	; If its on the first row, skip to the end, else...
INITAGAIN:
	INY		; used to keep track of the room height
	SEC
	SBC $07A5	; subtract Room Width from PLMs Nth position
	CMP $07A5	; compare to Room Width in Blocks (used to see if we are on the right row or not)
	BPL INITAGAIN	; If not on the right row, do it again. else...
INITEND:
	STA $1D77,X	; store the PLMs width for later
	TYA
	STA $1E17,X	; store the PLMs height for later
	LDA #$0001
	STA $7EDE1C,x	;PLM frame delay, always needed, 0 = wait 65365 frames...
	PLX
	PLY
	RTS

MAIN:
	PHY
	PHX
	JSR LOOP
	PLX
	PLY
	PLA
	RTS


LOOP:
	LDA #INST	;run this routine again
	STA $1D27,X	;Store at Next PLM instruction
	LDY #$0000	; set up current block's height variable
	LDA $0DC4	; current block's Nth position
	CMP $07A5	; Compare to Rooms Width in Blocks (used to see if its on the first line or not)
	BMI LOOPCMP	; If its on the first row, skip to the end, else...
LOOPAGAIN:
	INY		; used to keep track of the room height
	SEC
	SBC $07A5	; subtract Room Width from current block's Nth position
	CMP $07A5	; compare to Room Width in Blocks (used to see if we are on the right row or not)
	BPL LOOPAGAIN	; If not on the right row, do it again. else...
LOOPCMP:
	CMP $1D77,X	; compare to the the PLMs width
	BNE LOOPEND
	TYA
	CMP $1E17,X	; compare to the the PLMs height
	BNE LOOPEND
	LDA $1DC7,X	; PLM arguments
	AND #$00FF	; get rid of the stuff we don't want
	JSR $8081FA	; run the code to set the event state using the PLM arguments to set it
	RTS
LOOPEND:
	LDA #$0001
	STA $7EDE1C,X	;PLM frame delay, idling
	RTS
